// SeHackEd version 0.3
// Modified by Mike Fredericks, chohatsu@yahoo.com
// Thanks to Janis Legzdinsh for info, http://www.vavoom-engine.com
// based on DeHackEd version 3.0a
// Written by Greg Lewis, gregl@umich.edu
// If you release any versions of this code, please include
// the author in the credits.  Give credit where credit is due!

// This header contains lots of data arrays that are used elsewhere
// in the program and have no real home.

// Referenced for the Fielddata array
// Row of first data | num rows of data | type of mode (1 = columns)
char posinfo[NUMSCREENS][3] = { 0, 56, 0,
										 56,  6, 1,
										 62, 41, 0,
										104,  3, 1,
										107,  1, 1,
										108,  1, 1};

// Data to make cheat printing easier
int cheatinfo[17][2] = { 0,  4,
                                                                 8,  4,
                                                                20,  7,
                                                                28,  4,
                                                                33,  4,
                                                                38,  5,
                                                                46, 10,
                                                                57, 10,
                                                                68,  5,
                                                                74,  8,
                                                                83,  9,
                                                                93,  5,
                                                           99,  7, //B berserk
                                                          109,  7, //I invis
                                                          119,  7, //M enviro
                                                          129,  7, //H health
                                                          139,  7}; //P backpack
                                                          //149,  7}; //S stats
                                                          //159,  7}; //T targeter
                                                          //-5692,  4};

// Offsets in the exe for the various miscellaenous data pieces
long miscoffs[22][NUMVERS] = {
	0x5C858L, 0x5C848L, 0x5C838L, 0x629B8L, 0x62BD8L, // Inithealth
	0x5C877L, 0x5C867L, 0x5C857L, 0x629D7L, 0x62BF7L, // Initammo
	0x65A3AL, 0x659BAL, 0x65A1AL, 0x6BBBAL, 0x6BEFAL, // Maxhealth
	0x65A67L, 0x659E7L, 0x65A47L, 0x6BBE7L, 0x6BF27L, // Maxarmor
	0x659C7L, 0x65947L, 0x659A7L, 0x6BB47L, 0x6BE87L, // Greenarmorclass
	0x659FBL, 0x6597BL, 0x659DBL, 0x6BB7BL, 0x6BEBBL, // Bluearmorclass
	0x65A9AL, 0x65A1AL, 0x65A7AL, 0x6BC1AL, 0x6BF5AL, // Maxsoulhealth
	0x65A95L, 0x65A15L, 0x65A75L, 0x6BC15L, 0x6BF55L, // Soulhealth
	0x65AD3L, 0x65A53L, 0x65AB3L, 0x6BC53L, 0x6BF93L, // Megahealth
	0x759E3L, 0x75963L, 0x759C3L, 0x7BB63L, 0x7BEA3L, // godhealth
	0x75A33L, 0x759B3L, 0x75A13L, 0x7BBB3L, 0x7BEF3L, // IDFAarmor
	0x75A3FL, 0x759BFL, 0x75A1FL, 0x7BBBFL, 0x7BEFFL, // IDFAarmorclass
	0x75A97L, 0x75A17L, 0x75A77L, 0x7BC17L, 0x7BF57L, // IDKFAarmor
	0x75AA3L, 0x75A23L, 0x75A83L, 0x7BC23L, 0x7BF63L, // IDKFAarmorclass
	0x69318L, 0x69298L, 0x692F8L, 0x6F498L, 0x6F7D8L, // BFGammo
	0x66E22L, 0x66DA2L, 0x66E02L, 0x6CFA2L, 0x6D2E2L, // Infighting
	0x65A43L, 0x659C3L, 0x65A23L, 0x6BBC3L, 0x6BF03L, // Maxhealth  The last six rows are
	0x65A70L, 0x659F0L, 0x65A50L, 0x6BBF0L, 0x6BF30L, // Maxarmor   doubles for MAXHEALTH,
	0x65AA3L, 0x65A23L, 0x65A83L, 0x6BC23L, 0x6BF63L, // Maxsoul    MAXARMOR, MAXSOUL and
	0x759EFL, 0x7596FL, 0x759CFL, 0x7BB6FL, 0x7BEAFL, // Godhealth  GODHEALTH and BFGAMMO,
	0x695E1L, 0x69561L, 0x695C1L, 0x6F761L, 0x6FAA1L, // BFGammo    which need to be changed
	0x69103L, 0x69083L, 0x690E3L, 0x6F283L, 0x6F5C3L};// BFGammo    in several places.

// More data about the misc stuff... this time it is a list of how many
// bytes each piece of data is.
long miscsize[16] = {4, 4, 4, 4, 4, 4, 4, 1, 4, 4, 4, 4, 4, 4, 1, 1};

// y coord, x start, x end, hilite start, hilite end
char Fielddata[][5] = {13,  5, 30, 21, 31,	// Thing
							  14,  5, 30, 21, 31,
							  15,  5, 30, 21, 31,
							  16,  5, 30, 21, 31,
							  17,  5, 30, 21, 31,
							  18,  5, 30, 21, 31,
							  19,  5, 30, 21, 31,
							  20,  5, 30, 21, 31,
							  21,  5, 30, 21, 31,
							  22,  5, 30, 21, 31,
								4, 40, 65, 55, 66,
								5, 40, 65, 55, 66,
								6, 40, 65, 55, 66,
								7, 40, 65, 55, 66,
								8, 40, 65, 55, 66,
							  15, 37, 66, 57, 67,
							  16, 37, 66, 57, 67,
							  17, 37, 66, 57, 67,
							  18, 37, 66, 57, 67,
							  19, 37, 66, 57, 67,
							  20, 37, 66, 57, 67,
							  21, 37, 66, 57, 67,
							  22, 37, 66, 57, 67,
							  29, 11, 37, 15, 17,
							  30, 11, 37, 15, 17,
							  31, 11, 37, 15, 17,
							  32, 11, 37, 15, 17,
							  33, 11, 37, 15, 17,
							  34, 11, 37, 15, 17,
							  35, 11, 37, 15, 17,
							  36, 11, 37, 15, 17,
							  37, 11, 37, 15, 17,
							  38, 11, 37, 15, 17,
							  39, 11, 37, 15, 17,
							  40, 11, 37, 15, 17,
							  41, 11, 37, 15, 17,
							  42, 11, 37, 15, 17,
							  43, 11, 37, 15, 17,
							  44, 11, 37, 15, 17,
							  29, 41, 67, 45, 47,
							  30, 41, 67, 45, 47,
							  31, 41, 67, 45, 47,
							  32, 41, 67, 45, 47,
							  33, 41, 67, 45, 47,
							  34, 41, 67, 45, 47,
							  35, 41, 67, 45, 47,
							  36, 41, 67, 45, 47,
							  37, 41, 67, 45, 47,
							  38, 41, 67, 45, 47,
							  39, 41, 67, 45, 47,
							  40, 41, 67, 45, 47,
							  41, 41, 67, 45, 47,
							  42, 41, 67, 45, 47,
							  43, 41, 67, 45, 47,
							  44, 41, 67, 45, 47,
								5,  4, 33, 17, 33,

								0, 21, 26, 22, 26,	// Frame
								0, 27, 29, 28, 30,
								0, 34, 36, 35, 37,
								0, 40, 49, 41, 50,
								0, 51, 59, 52, 60,
								0, 60, 69, 61, 70,

							  35, 21, 49, 39, 50,	// Misc
							  36, 21, 49, 39, 50,
							  37, 21, 49, 39, 50,
							  38, 21, 49, 39, 50,
							  39, 21, 49, 39, 50,
							  40, 21, 49, 39, 50,
							  41, 21, 49, 39, 50,
							  42, 21, 49, 39, 50,
								7, 45, 72, 64, 73,
								8, 45, 72, 64, 73,
								9, 45, 72, 64, 73,
							  10, 45, 72, 64, 73,
							  11, 45, 72, 64, 73,
							  12, 45, 72, 64, 73,
							  13, 45, 72, 64, 73,
							  14, 45, 72, 64, 73,
							  15, 45, 72, 64, 73,
							  16, 45, 72, 64, 73,
							  17, 45, 72, 64, 73,
							  18, 45, 72, 64, 73,
							  19, 45, 72, 64, 73,
							  20, 45, 72, 64, 73,
							  21, 45, 72, 64, 73,
							  22, 45, 72, 64, 73,
							  23, 45, 72, 64, 73,
								8,  6, 36, 26, 35,
								9,  6, 36, 26, 35,
							  10,  6, 36, 26, 35,
							  11,  6, 36, 26, 35,
							  12,  6, 36, 26, 35,
							  13,  6, 36, 26, 35,
							  14,  6, 36, 26, 35,
							  15,  6, 36, 26, 35,
							  16,  6, 36, 26, 35,
							  17,  6, 36, 26, 35,
							  18,  6, 36, 26, 35,
							  19,  6, 36, 26, 35,
							  20,  6, 36, 26, 35,
							  21,  6, 36, 26, 35,
							  22,  6, 36, 26, 35,
							  23,  6, 36, 26, 35,
							  24,  6, 36, 26, 35,

								0, 34, 41, 35, 42,	// Sound
								0, 43, 49, 44, 50,
								0, 52, 61, 53, 62,

								0, 36, 42, 36, 44,	// Sprite

								0, 13, 74, 13, 75};	// Code pointer

// Data for offsets of all the code pointers
// Offsets are calculated according to the following formulae, which
// then applied to the respective Doom exes.
//      Doom v1.666, 1.7a  - (2279+framenum)*28
//      Doom v1.9          - 64052+(framenum*28)
//      Doom v1.9 Ultimate - (2291+framenum)*28
//int codepoff[725][3]; // changed 448 to 725 but don't know offsets
int codepoff[725][3] = {
			171,  216,  225,
			162,  207,  216,
			387,  432,  441,
			378,  423,  432,
			369,  414,  423,
			432,  477,  486,
			423,  468,  477,
			414,  459,  468,
			405,  450,  459,
			396,  441,  450,
			477,  522,  531,
         468,  513,  522,
         459,  504,  513,
         450,  495,  504,
         441,  486,  495,
         486,  531,  540,
         531,  576,  585,
         522,  567,  576,
         513,  558,  567,
         504,  549,  558,
         495,  540,  549,
         567,    9,   27,
         558,    0,   18,
         549,  594,    9,
         540,  585,    0,
         594,   36,   54,
         585,   27,   45,
         576,   18,   36,
			 18,   81,   81,
           9,   72,   72,
           0,   63,   63,
         612,   54, 2169,
         603,   45, 2160,
          72,   90, 2223,
          63, 2187, 2214,
          54, 2178, 2205,
          45, 2169, 2196,
          36, 2160, 2187,
          27, 2151, 2178,
         108, 2241, 2277,
          99, 2232, 2268,
          90, 2223, 2259,
          81, 2214, 2250,
        2142, 2205, 2241,
        2133, 2196, 2232,
		  2196, 2295, 2331,
        2187, 2286, 2322,
        2178, 2277, 2313,
        2169, 2268, 2304,
        2160, 2259, 2295,
        2151, 2250, 2286,
        2250, 2349, 2385,
        2241, 2340, 2376,
        2232, 2331, 2367,
        2223, 2322, 2358,
        2214, 2313, 2349,
        2205, 2304, 2340,
        2304, 2403, 2439,
        2295, 2394, 2430,
        2286, 2385, 2421,
        2277, 2376, 2412,
        2268, 2367, 2403,
        2259, 2358, 2394,
		  2358, 2457, 2493,
        2349, 2448, 2484,
        2340, 2439, 2475,
        2331, 2430, 2466,
        2322, 2421, 2457,
        2313, 2412, 2448,
        2367, 2466, 2502,
        2376, 2475, 2511,
        2385, 2484, 2520,
        2412, 2511, 2547,
        2403, 2502, 2538,
        2394, 2493, 2529,
        2430, 2529, 2565,
        2421, 2520, 2556,
        2439, 2538, 2574,
        2493, 2592, 2628,
        2484, 2583, 2619,
		  2475, 2574, 2610,
        2466, 2565, 2601,
        2457, 2556, 2592,
        2448, 2547, 2583,
        2538, 2637, 2115,
        2529, 2628, 2106,
        2520, 2619, 2655,
        2511, 2610, 2646,
        2502, 2601, 2637,
        2565, 2124, 2142,
        2556, 2115, 2133,
        2547, 2646, 2124,
        2583, 2142, 2151,
        2574, 2133, 3051,
        2592, 3078, 3096,
        3024, 3069, 3087,
        3015, 3060, 3078,
        3006, 3051, 3069,
		  2997, 3042, 3060,
        3078, 3132, 3150,
        3069, 3123, 3141,
        3060, 3114, 3132,
        3051, 3105, 3123,
        3042, 3096, 3114,
        3033, 3087, 3105,
        3105, 3159, 3177,
        3096, 3150, 3168,
        3087, 3141, 3159,
        3132, 3186, 3204,
        3123, 3177, 3195,
        3114, 3168, 3186,
        3150, 3204, 3222,
        3141, 3195, 3213,
        3204, 3258, 3276,
        3195, 3249, 3267,
		  3186, 3240, 3258,
        3177, 3231, 3249,
        3168, 3222, 3240,
        3159, 3213, 3231,
        3258, 3312, 3330,
        3249, 3303, 3321,
        3240, 3294, 3312,
        3231, 3285, 3303,
        3222, 3276, 3294,
        3213, 3267, 3285,
        3312, 3366, 3384,
        3303, 3357, 3375,
        3294, 3348, 3366,
        3285, 3339, 3357,
        3276, 3330, 3348,
        3267, 3321, 3339,
        3348, 3402, 3420,
        3339, 3393, 3411,
		  3330, 3384, 3402,
        3321, 3375, 3393,
        3366, 3420, 3438,
        3357, 3411, 3429,
        3375, 3429, 3447,
        3420, 3474, 3492,
        3411, 3465, 3483,
        3402, 3456, 3474,
        3393, 3447, 3465,
        3384, 3438, 3456,
        3474, 3528, 3546,
        3465, 3519, 3537,
        3456, 3510, 3528,
        3447, 3501, 3519,
        3438, 3492, 3510,
        3429, 3483, 3501,
        2628, 2691, 2709,
		  2619, 2682, 2700,
        2610, 2673, 2691,
        2601, 2664, 2682,
        3492, 2655, 2673,
        3483, 3537, 2664,
        2682, 2745, 2763,
        2673, 2736, 2754,
        2664, 2727, 2745,
        2655, 2718, 2736,
        2646, 2709, 2727,
        2637, 2700, 2718,
        2736, 2799, 2817,
        2727, 2790, 2808,
        2718, 2781, 2799,
        2709, 2772, 2790,
        2700, 2763, 2781,
        2691, 2754, 2772,
        2745, 2808, 2826,
		  2781, 2844, 2862,
        2772, 2835, 2853,
        2763, 2826, 2844,
        2754, 2817, 2835,
        2835, 2898, 2916,
        2826, 2889, 2907,
        2817, 2880, 2898,
        2808, 2871, 2889,
        2799, 2862, 2880,
        2790, 2853, 2871,
        2889, 2952, 2970,
        2880, 2943, 2961,
        2871, 2934, 2952,
        2862, 2925, 2943,
        2853, 2916, 2934,
        2844, 2907, 2925,
        2943, 3006, 3024,
		  2934, 2997, 3015,
        2925, 2988, 3006,
        2916, 2979, 2997,
        2907, 2970, 2988,
        2898, 2961, 2979,
        2970, 3033, 3042,
        2961, 3024, 3033,
        2952, 3015, 3780,
        2988, 3789, 3798,
        2979, 3780, 3789,
        3753, 3825, 3834,
        3744, 3816, 3825,
        3735, 3807, 3816,
        3726, 3798, 3807,
        3807, 3879, 3888,
        3798, 3870, 3879,
        3789, 3861, 3870,
        3780, 3852, 3861,
		  3771, 3843, 3852,
        3762, 3834, 3843,
        3861, 3933, 3942,
        3852, 3924, 3933,
        3843, 3915, 3924,
        3834, 3906, 3915,
        3825, 3897, 3906,
        3816, 3888, 3897,
        3915, 3987, 3996,
        3906, 3978, 3987,
        3897, 3969, 3978,
        3888, 3960, 3969,
        3879, 3951, 3960,
        3870, 3942, 3951,
        3951, 4023, 4032,
        3942, 4014, 4023,
        3933, 4005, 4014,
		  3924, 3996, 4005,
        3960, 4032, 4041,
        3969, 4041, 4050,
        3996, 4068, 4077,
        3987, 4059, 4068,
        3978, 4050, 4059,
        4050, 4122, 4131,
        4041, 4113, 4122,
        4032, 4104, 4113,
        4023, 4095, 4104,
        4014, 4086, 4095,
        4005, 4077, 4086,
        4095, 4167, 4176,
        4086, 4158, 4167,
        4077, 4149, 4158,
        4068, 4140, 4149,
        4059, 4131, 4140,
        4122, 4194, 4203,
		  4113, 4185, 4194,
        4104, 4176, 4185,
        4140, 4212, 4221,
        4131, 4203, 4212,
        4167, 4239, 4248,
        4158, 4230, 4239,
        4149, 4221, 4230,
        3501, 3564, 3582,
        4221, 3555, 3573,
        4212, 3546, 3564,
        4203, 4275, 3555,
        4194, 4266, 4275,
        4185, 4257, 4266,
        4176, 4248, 4257,
        3537, 3600, 3618,
        3528, 3591, 3609,
        3519, 3582, 3600,
		  3510, 3573, 3591,
        3564, 3627, 3645,
        3555, 3618, 3636,
        3546, 3609, 3627,
        3573, 3636, 3654,
        3582, 3645, 3663,
        3636, 3699, 3717,
        3627, 3690, 3708,
        3618, 3681, 3699,
        3609, 3672, 3690,
        3600, 3663, 3681,
        3591, 3654, 3672,
        3690, 3753, 3771,
        3681, 3744, 3762,
        3672, 3735, 3753,
        3663, 3726, 3744,
        3654, 3717, 3735,
        3645, 3708, 3726,
		  3717, 3771, 4491,
        3708, 3762, 4482,
        3699, 4491, 4473,
        4536, 4536, 4536,
        4527, 4527, 4527,
        4518, 4518, 4518,
        4509, 4509, 4509,
        4500, 4500, 4500,
        4554, 4554, 4554,
        4545, 4545, 4545,
        4563, 4563, 4563,
        4599, 4599, 4599,
        4590, 4590, 4590,
        4581, 4581, 4581,
        4572, 4572, 4572,
        4662, 4662, 4662,
        4653, 4653, 4653,
		  4644, 4644, 4644,
        4635, 4635, 4635,
        4626, 4626, 4626,
        4617, 4617, 4617,
        4608, 4608, 4608,
        4698, 4698, 4698,
        4689, 4689, 4689,
        4680, 4680, 4680,
        4671, 4671, 4671,
        4716, 4716, 4716,
        4707, 4707, 4707,
        4770, 4770, 4770,
        4761, 4761, 4761,
        4752, 4752, 4752,
        4743, 4743, 4743,
        4734, 4734, 4734,
        4725, 4725, 4725,
        4824, 4824, 4824,
		  4815, 4815, 4815,
        4806, 4806, 4806,
        4797, 4797, 4797,
        4788, 4788, 4788,
        4779, 4779, 4779,
        4851, 4851, 4851,
        4842, 4842, 4842,
        4833, 4833, 4833,
        4860, 4860, 4860,
        4878, 4878, 4878,
        4869, 4869, 4869,
        4914, 4914, 4914,
        4905, 4905, 4905,
        4896, 4896, 4896,
        4887, 4887, 4887,
        4941, 4941, 4941,
        4932, 4932, 4932,
		  4923, 4923, 4923,
        4977, 4977, 4284,
        4968, 4968, 4968,
        4959, 4959, 4959,
        4950, 4950, 4950,
        4257, 4320, 4338,
        4248, 4311, 4329,
        4239, 4302, 4320,
        4230, 4293, 4311,
        4995, 4284, 4302,
        4986, 4986, 4293,
        4311, 4374, 4392,
        4302, 4365, 4383,
        4293, 4356, 4374,
        4284, 4347, 4365,
        4275, 4338, 4356,
        4266, 4329, 4347,
        4356, 4419, 4437,
		  4347, 4410, 4428,
        4338, 4401, 4419,
        4329, 4392, 4410,
        4320, 4383, 4401,
        4392, 4455, 4464,
        4383, 4446, 4455,
        4374, 4437, 4446,
        4365, 4428, 5184,
        4446, 4482, 5238,
        4437, 4473, 5229,
        4428, 4464, 5220,
        4419, 5202, 5211,
        4410, 5193, 5202,
        4401, 5184, 5193,
        4491, 5256, 5292,
        4482, 5247, 5283,
        4473, 5238, 5274,
		  4464, 5229, 5265,
        4455, 5220, 5256,
        5193, 5211, 5247,
        5229, 5292, 5328,
        5220, 5283, 5319,
        5211, 5274, 5310,
        5202, 5265, 5301,
        5247, 5310, 5346,
        5238, 5301, 5337,
        5292, 5355, 5391,
        5283, 5346, 5382,
        5274, 5337, 5373,
        5265, 5328, 5364,
        5256, 5319, 5355,
        5346, 5409, 5445,
        5337, 5400, 5436,
        5328, 5391, 5427,
        5319, 5382, 5418,
		  5310, 5373, 5409,
        5301, 5364, 5400,
        5400, 5463, 5499,
        5391, 5454, 5490,
        5382, 5445, 5481,
        5373, 5436, 5472,
        5364, 5427, 5463,
        5355, 5418, 5454,
        5418, 5481, 5517,
        5409, 5472, 5508,
        5445, 5508, 5544,
        5436, 5499, 5535,
        5427, 5490, 5526,
        5508, 5571, 5607,
        5499, 5562, 5598,
        5490, 5553, 5589,
        5481, 5544, 5580,
		  5472, 5535, 5571,
        5463, 5526, 5562,
        5454, 5517, 5553,
        5544, 5607, 5643,
        5535, 5598, 5634,
        5526, 5589, 5625,
        5517, 5580, 5616,
        5553, 5616, 5652,
        5571, 5634, 5670,
        5562, 5625, 5661,
        5625, 4995, 5013,
        5616, 5679, 5004,
        5607, 5670, 4995,
        5598, 5661, 4986,
        5589, 5652, 4977,
        5580, 5643, 5679,
        5679, 5049, 5067,
        5670, 5040, 5058,
		  5661, 5031, 5049,
        5652, 5022, 5040,
        5643, 5013, 5031,
        5634, 5004, 5022,
        5022, 5085, 5103,
        5013, 5076, 5094,
        5004, 5067, 5085,
        5688, 5058, 5076,
        5049, 5112, 5130,
        5040, 5103, 5121,
        5031, 5094, 5112,
        5058, 5121, 5139,
        5067, 5130, 5148,
        5094, 5157, 5175,
        5085, 5148, 5166,
        5076, 5139, 5157,
        5148, 5175, 5733,
		  5139, 5166, 5724,
		  5130, 5715, 5715,
		  5121, 5706, 5706,
		  5112, 5697, 5697,
		  5103, 5688, 5688,
		  5184, 5778, 5796,
		  5175, 5769, 5787,
		  5166, 5760, 5778,
		  5157, 5751, 5769,
		  5715, 5742, 5760,
		  5706, 5733, 5751,
		  5697, 5724, 5742,
		  5751, 5814, 5832,
		  5742, 5805, 5823,
		  5733, 5796, 5814,
		  5724, 5787, 5805,
		  5769, 5832, 5850,
                  5760, 5823, 5841};

// A conversion array to convert from the 448 code pointers to the 966
// Frames that exist.
//int codepconv[725];  // changed 448 to 725 and all the codep frames
int codepconv[725] = {  1, 13, 14, 15, 17, 20, 21, 22, 23, 24,
                         25, 30, 34, 35, 36, 38, 43, 44, 45, 46,
                         47, 48, 50, 52, 53, 54, 55, 56, 57, 58,
                         59, 60, 62, 63, 64, 65, 66, 67, 68, 69,
                         70, 71, 72, 73, 74, 75, 76, 79, 81, 82,
                         83, 84, 85, 86, 87, 88, 89, 90, 91, 93,
                         94, 95, 96, 97, 98, 100, 102, 103, 104, 105,
                        106, 107, 108, 109, 111, 113, 114, 115, 116, 117,
                        122, 123, 124, 125, 126, 127, 128, 129, 130, 153,
                        154, 183, 184, 185, 186, 187, 188, 189, 198, 212,
                        220, 221, 222, 223, 224, 225, 226, 227, 228, 229,
                        231, 234, 235, 238, 239, 240, 241, 242, 250, 257,
                        294, 297, 298, 306, 307, 308, 309, 310, 311, 312,
                        320, 321, 334, 336, 339, 349, 350, 351, 352, 353,
                        354, 355, 356, 357, 358, 359, 360, 361, 372, 376,
                        383, 384, 385, 386, 387, 388, 389, 390, 391, 392,
                        393, 396, 398, 401, 403, 408, 409, 410, 411, 412,
                        413, 414, 418, 419, 421, 422, 442, 443, 444, 445,
                        446, 448, 450, 452, 456, 457, 458, 459, 460, 461,
                        462, 464, 465, 466, 467, 468, 470, 472, 478, 479,
                        482, 483, 484, 485, 486, 487, 488, 489, 490, 491,
                        492, 493, 494, 495, 496, 497, 498, 499, 500, 502,
                        504, 505, 511, 512, 513, 514, 515, 516, 519, 522,
                        523, 524, 525, 526, 527, 528, 529, 530, 531, 532,
                        533, 534, 535, 536, 538, 539, 540, 541, 543, 547,
                        558, 565, 566, 567, 568, 569, 570, 571, 572, 573,
                        574, 575, 576, 577, 578, 580, 581, 583, 585, 587,
                        591, 593, 594, 595, 596, 597, 598, 600, 601, 603,
                        604, 605, 606, 607, 608, 609, 610, 611, 612, 613,
                        614, 615, 616, 617, 618, 619, 620, 621, 622, 624,
                        627, 629, 631, 632, 633, 634, 635, 636, 640, 643,
                        646, 647, 648, 649, 650, 651, 652, 653, 654, 655,
                        656, 657, 658, 660, 661, 662, 663, 664, 667, 681,
                        682, 683, 684, 685, 686, 687, 688, 689, 690, 691,
                        692, 693, 694, 695, 696, 697, 698, 699, 700, 701,
                        702, 703, 704, 705, 706, 707, 708, 709, 710, 711,
                        712, 713, 714, 715, 716, 717, 718, 719, 720, 721,
                        722, 724, 725, 726, 729, 731, 733, 735, 737, 738,
                        750, 752, 756, 757, 758, 759, 760, 761, 762, 763,
                        764, 765, 766, 767, 768, 769, 770, 771, 773, 775,
                        792, 796, 797, 798, 799, 800, 801, 802, 803, 804,
                        805, 806, 807, 808, 809, 810, 812, 813, 815, 816,
                        817, 818, 821, 823, 829, 833, 852, 853, 855, 856,
                        857, 858, 859, 860, 861, 862, 863, 864, 865, 866,
                        867, 868, 869, 870, 871, 872, 873, 874, 875, 876,
                        877, 878, 880, 881, 883, 884, 885, 887, 888, 890,
                        891, 892, 893, 894, 895, 896, 897, 898, 899, 900,
                        901, 902, 903, 904, 905, 906, 907, 908, 909, 910,
                        911, 912, 913, 914, 915, 916, 918, 919, 921, 922,
                        923, 924, 925, 926, 927, 928, 929, 930, 931, 932,
                        933, 934, 935, 936, 937, 938, 939, 940, 941, 942,
                        943, 944, 945, 946, 947, 948, 949, 950, 951, 952,
                        953, 954, 955, 956, 957, 959, 961, 963, 966, 967,
                        976, 977, 978, 979, 980, 986, 987, 988, 989, 990,
                        991, 992, 993, 994, 995, 996, 997, 998, 999, 1000,
                       1001, 1002, 1003, 1004, 1005, 1006, 1009, 1010, 1011, 1012,
                       1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1027, 1028,
                       1029, 1030, 1031, 1032, 1033, 1035, 1040, 1047, 1048, 1049,
                       1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059,
                       1060, 1061, 1062, 1064, 1065, 1066, 1067, 1068, 1069, 1070,
                       1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080,
                       1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1093,
                       1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
                       1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
                       1114, 1115, 1116, 1117, 1118, 1126, 1127, 1137, 1138, 1144,
                       1145, 1147, 1148, 1149, 1150, 1151, 1160, 1161, 1162, 1163,
                       1164, 1166, 1173, 1174, 1175, 1176, 1177, 1179, 1181, 1183,
                       1186, 1191, 1192, 1193, 1194, 1197, 1198, 1200, 1201, 1202,
                       1205, 1211, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223,
                       1224, 1225, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1294,
                       1298, 1300, 1306, 1309, 1310, 1358, 1359, 1360, 1361, 1362,
                       1363, 1389, 1390, 1391, 1392, 1437, 1438, 1439, 1440, 1471,
                       1473, 1476, 1479, 1492, 1496};

// Thing conversion array from 1.2 to 1.666
unsigned char thingconvar[104]={ 0,  11,   1,   2,  12,  13,  14,  18,  15,  19,
										  21,  30,  31,  32,  16,  33,  34,  35,  37,  38,
										  39,  41,  42,  43,  44,  45,  46,  47,  48,  49,
										  50,  51,  52,  53,  54,  55,  56,  57,  58,  59,
										  60,  61,  63,  64,  65,  66,  67,  68,  69,  70,
										  71,  72,  73,  74,  75,  76,  77,  81,  82,  83,
										  84,  85,  86,  87,  88,  89,  90,  91,  92,  93,
										  94,  95,  96,  97,  98,  99, 100, 101, 102, 103,
										 104, 105, 106, 107, 108, 109, 110, 111, 112, 113,
										 114, 115, 116, 117, 118, 119, 120, 121, 122, 123,
										 124, 125, 126, 137};

// Frame conversion array from 1.2 to 1.666
int frameconvar[512]={	0,   1,   2,   3,   4,   5,   6,   7,   8,   9,
							  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,
							  20,  21,  22,  23,  24,  25,  26,  27,  28,  29,
							  30,  31,  49,  50,  51,  52,  53,  54,  55,  56,
							  57,  58,  59,  60,  61,  62,  63,  64,  65,  66,
							  67,  68,  69,  70,  71,  72,  73,  74,  75,  76,
							  77,  78,  79,  80,  81,  82,  83,  84,  85,  86,
							  87,  88,  89,  90,  91,  92,  93,  94,  95,  96,
							  97,  98,  99, 100, 101, 102, 103, 104, 105, 106,
							 522, 523, 524, 525, 526, 107, 108, 109, 110, 111,
/* 100 */				 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
							 122, 123, 124, 125, 126, 127, 128, 129, 149, 150,
							 151, 152, 153, 154, 155, 156, 157, 158, 159, 160,
							 161, 162, 163, 164, 165, 166, 167, 168, 169, 170,
							 171, 172, 173, 174, 175, 176, 177, 178, 179, 180,
							 181, 182, 183, 184, 185, 186, 187, 188, 189, 190,
							 191, 192, 193, 194, 195, 196, 197, 198, 199, 200,
							 201, 202, 207, 208, 209, 210, 211, 212, 213, 214,
							 215, 216, 217, 218, 219, 220, 221, 222, 223, 224,
							 225, 226, 227, 228, 229, 230, 231, 232, 233, 234,
/* 200 */				 235, 442, 443, 444, 445, 446, 447, 448, 449, 450,
							 451, 452, 453, 454, 455, 456, 457, 458, 459, 460,
							 461, 462, 463, 464, 465, 466, 467, 468, 469, 475,
							 476, 477, 478, 479, 480, 481, 482, 483, 484, 485,
							 486, 487, 488, 489, 490, 491, 492, 493, 494, 495,
							 502, 503, 504, 505, 506, 507, 508, 509, 510, 511,
							 512, 513, 514, 515, 527, 528, 529, 530, 531, 532,
							 533, 534, 535, 536, 537, 538, 539, 540, 541, 542,
							 543, 544, 545, 546, 547, 548, 585, 586, 587, 588,
							 589, 590, 591, 592, 593, 594, 595, 596, 597, 598,
/* 300 */				 599, 600, 601, 602, 603, 604, 605, 606, 607, 608,
							 609, 610, 611, 612, 613, 614, 615, 616, 617, 618,
							 619, 620, 621, 622, 623, 624, 625, 626, 627, 628,
							 629, 630, 631, 674, 675, 676, 677, 678, 679, 680,
							 681, 682, 683, 684, 685, 686, 687, 688, 689, 690,
							 691, 692, 693, 694, 695, 696, 697, 698, 699, 700,
							 130, 131, 132, 133, 134, 135, 136, 137, 138, 139,
							 140, 141, 802, 803, 804, 805, 806, 807, 808, 809,
							 810, 811, 812, 816, 817, 818, 819, 820, 821, 822,
							 823, 824, 825, 826, 827, 828, 829, 830, 831, 832,
/* 400 */				 833, 834, 835, 836, 837, 838, 839, 840, 841, 842,
							 843, 844, 845, 846, 847, 848, 849, 850, 851, 852,
							 853, 854, 855, 856, 861, 862, 863, 864, 865, 866,
							 867, 868, 869, 870, 871, 872, 873, 874, 875, 876,
							 877, 878, 879, 880, 881, 882, 883, 884, 886, 887,
							 888, 889, 890, 891, 892, 893, 894, 895, 896, 897,
							 898, 899, 900, 901, 902, 903, 904, 905, 906, 907,
							 908, 909, 910, 911, 912, 913, 914, 915, 916, 917,
							 918, 919, 920, 921, 922, 923, 924, 925, 926, 927,
							 928, 929, 930, 931, 932, 933, 934, 935, 936, 937,
/* 500 */				 938, 939, 940, 941, 942, 943, 944, 945, 946, 947,
							 948, 949};

// Sound conversion array from 1.2 to 1.666
unsigned char soundconvar[63] = { 0,  1,  2,  3,  8,  9, 10, 11, 12, 13,
											14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
											24, 25, 26, 27, 31, 32, 33, 34, 35, 36,
											37, 38, 39, 40, 41, 42, 43, 44, 45, 51,
											52, 55, 57, 59, 60, 61, 62, 63, 64, 65,
											66, 67, 68, 69, 75, 76, 77, 81, 82, 83,
											84, 85, 86};

// Sprite conversion array from 1.2 to 1.666
unsigned char spriteconvar[105]={  0,   1,   2,   3,   4,   5,   7,   8,   9,  10,
											 11,  12,  13,  14,  15,  16,  17,  18,  19,  41,
											 20,  21,  22,  23,  24,  25,  28,  29,  30,  39,
											 40,  42,  44,  45,  49,  26,  55,  56,  57,  58,
											 60,  61,  62,  63,  64,  65,  66,  67,  68,  69,
											 70,  71,  72,  73,  75,  76,  77,  78,  79,  80,
											 81,  82,  83,  84,  85,  86,  87,  88,  89,  90,
											 91,  92,  94,  95,  96,  97,  98,  99, 100, 101,
											102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
											112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
											122, 123, 124, 125, 126};
